/******************************************************************************
;  *       @型号                 : MC51F003A4
;  *       @创建日期             : 2023.02.01
;  *       @公司/作者            : SINOMCU.COM-AE
;  *       @晟矽微官网           : http://www.sinomcu.com/
;  *       @版权                 : 晟矽微电 版权所有.
;  *----------------------摘要描述---------------------------------
;  *                                                                      
******************************************************************************/

#ifndef User_Def_H__
#define User_Def_H__

#include <stdio.h>
#include "MC51F003A4_COMMON.h"
#include "user_config.h"
#include "GPIO.h"
#include "TIMER.h"
#include "UART.h"
#include "MUL_DIV.h"

#define EN_MUL_DIV_16()            DPS |= ((0x03)<<2)

typedef union {
  unsigned char byte;
  struct
  {
    uint8_t bit0 : 1;
    uint8_t bit1 : 1;
    uint8_t bit2 : 1;
    uint8_t bit3 : 1;
    uint8_t bit4 : 1;
    uint8_t bit5 : 1;
    uint8_t bit6 : 1;
    uint8_t bit7 : 1;
  } bits;
} B4BIT;      /*byte for bit*/

extern __O B4BIT SFR_interrupt_buff_H;
extern __O B4BIT SFR_interrupt_buff_L;

//IE
#define SFR_INTERRUPT_BUFF_BIT_INT0              SFR_interrupt_buff_H.bits.bit0      
#define SFR_INTERRUPT_BUFF_BIT_T0                SFR_interrupt_buff_H.bits.bit1
#define SFR_INTERRUPT_BUFF_BIT_INT1              SFR_interrupt_buff_H.bits.bit2
#define SFR_INTERRUPT_BUFF_BIT_T1                SFR_interrupt_buff_H.bits.bit3
#define SFR_INTERRUPT_BUFF_BIT_UART0             SFR_interrupt_buff_H.bits.bit4
#define SFR_INTERRUPT_BUFF_BIT_SPI               SFR_interrupt_buff_H.bits.bit5
#define SFR_INTERRUPT_BUFF_BIT_ADC               SFR_interrupt_buff_H.bits.bit6
#define SFR_INTERRUPT_BUFF_BIT_EA                SFR_interrupt_buff_H.bits.bit7

//IE1
#define SFR_INTERRUPT_BUFF_BIT_T2                SFR_interrupt_buff_H.bits.bit0
#define SFR_INTERRUPT_BUFF_BIT_T3                SFR_interrupt_buff_L.bits.bit1
#define SFR_INTERRUPT_BUFF_BIT_PWM1              SFR_interrupt_buff_L.bits.bit2      
#define SFR_INTERRUPT_BUFF_BIT_UART1             SFR_interrupt_buff_L.bits.bit3
#define SFR_INTERRUPT_BUFF_BIT_PWM0              SFR_interrupt_buff_L.bits.bit4
#define SFR_INTERRUPT_BUFF_BIT_PWM1_FB           SFR_interrupt_buff_L.bits.bit5
#define SFR_INTERRUPT_BUFF_BIT_CRC               SFR_interrupt_buff_L.bits.bit7

#endif

/**************************** end of file *********************************************/
