/******************************************************************************
;  *       @ͺ                 : MC51F003A4
;  *       @             : 2023.02.01
;  *       @˾/            : SINOMCU.COM-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢ Ȩ.
;  *----------------------ժҪ---------------------------------
;  * ʼUART1                                  
******************************************************************************/

#include "User_Def.h"

/************************************************
;  *    @Function Name       : UART1_Init,baud used timer2
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void UART1_Init(uint16_t uart_baud) {
  uint16_t baud_rate_cacl=0; 
  SET_UART1EN();                       /*ʹUART1 */

  Uart1_Mode_Set(UART_MODE_01);        /*ʽ1,8bit */ 
  Uart1_REN_set();                     /* */
  Uart1_Sel_T2();                      /*UART baud used Timer2*/

  T2CON1 |= DEF_SET_BIT0;              /*ʹT2 */    
  T2_Pre_Scale(T2_PRE_SCALE_1);        /*Ƶ*/
  baud_rate_cacl =  (65536 - FSYS_CLOCK/16/uart_baud);    

  RCAPL2=(uint8_t)(baud_rate_cacl);
  RCAPH2=(uint8_t)(baud_rate_cacl >>8);
  TL2=RCAPL2;
  TH2=RCAPH2;
  T2_Baud_En();                        /*Timer2 16bit reload baud*/

  Timer2_En();   
  //UART1_INTR_En();                   /*UART1ж*/
}

/************************************************
;  *    @Function Name       : putchar
;  *    @Description         : ضprintfUART
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
char putchar(char tx_data) {
#if(defined(EN_PRINT_UART) && EN_PRINT_UART) 
  SBUF_1 = tx_data;                    /*дݵUARTݼĴ*/
  while (!Read_Uart1_TI()) { ;}        /*ȴǰݷ*/
  Uart1_TI_clear();
#endif
  return tx_data;
}

/************************************************
;  *    @Function Name       : UART1_ISR
;  *    @Description         : UART1жϷ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void UART1_ISR(void) interrupt UART1_IRQn {
  SFR_INTERRUPT_BUFF_BIT_UART1 = SFRSL0;         /*жϻSFR*/
  if(Read_Uart1_RI()) {
    Uart1_RI_clear();
  }
  if(Read_Uart1_TI()) {
    Uart1_TI_clear();
  }
  SFRSL0 = SFR_INTERRUPT_BUFF_BIT_UART1;         /*˳жϻԭSFR*/
}
/**************************** end of file *********************************************/
